<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content interface">
                   <div class="content-data">












<ol class="breadcrumb">
  <li>Interfaces</li>
  <li>UseCaseMetaData</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>e2e/shared/mock-server.ts</code>
        </p>



        <section>
            <h3 id="index">Index</h3>
            <table class="table table-sm table-bordered index-table">
                <tbody>
                    <tr>
                        <td class="col-md-4">
                            <h6><b>Properties</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                        <a href="#protocolInstanceId">protocolInstanceId</a>
                                </li>
                                <li>
                                        <a href="#votingCards">votingCards</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
            </table>
        </section>



            <section>
                <h3 id="inputs">Properties</h3>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="protocolInstanceId"></a>
                                        <span class="name"><b>protocolInstanceId</b><a href="#protocolInstanceId"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>protocolInstanceId:     <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="votingCards"></a>
                                        <span class="name"><b>votingCards</b><a href="#votingCards"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>votingCards:     <code><a href="../interfaces/VotingCard.html" target="_self" >VotingCard[]</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>    <code><a href="../interfaces/VotingCard.html" target="_self" >VotingCard[]</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
            </section>
    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { browser, promise, protractor } from &#x27;protractor&#x27;;
import { log } from &#x27;util&#x27;;

const request &#x3D; require(&quot;request&quot;);

function doRequest(path: string) {
  let deferred &#x3D; protractor.promise.defer&lt;any&gt;();
  let url &#x3D; &#x60;http://${browser.params.mockServer.hostname}:${browser.params.mockServer.port}/${path}&#x60;;
  request(url,
    {json: true, proxy: &quot;&quot;},
    (err, res, body) &#x3D;&gt; {
      if (err) {
        return console.log(err);
      }
      deferred.fulfill(body);
    });

  return deferred.promise;
}

export function resetDB() {
  log(&#x27;resetting database&#x27;);
  return doRequest(&#x27;/mock/database/reset&#x27;);
}

export enum Canton {
  GE &#x3D; &quot;GE&quot;, AG &#x3D; &quot;AG&quot;, SG &#x3D; &quot;SG&quot;, BE &#x3D; &quot;BE&quot;, BS &#x3D; &quot;BS&quot;, LU &#x3D; &quot;LU&quot;
}

export enum TestCaseType {
  TEST &#x3D; &quot;TEST&quot;,
  SIMULATION &#x3D; &quot;SIMULATION&quot;,
  REAL &#x3D; &quot;REAL&quot;
}

export enum DateType {
  PAST &#x3D; &quot;PAST&quot;,
  NOW &#x3D; &quot;NOW&quot;,
  FUTURE &#x3D; &quot;FUTURE&quot;
}

export interface VotingCard {
  voterId: number,
  cardNumber: string,
  confirmationCode: string,
  finalizationCode: string,
  verificationCodes: string[]
}

export interface UseCaseMetaData {
  protocolInstanceId: string,
  votingCards: VotingCard[]
}

export function createUseCase(election &#x3D; false,
                              votation &#x3D; true,
                              type: TestCaseType &#x3D; TestCaseType.TEST,
                              canton: Canton &#x3D; Canton.GE,
                              groupedVotation &#x3D; true,
                              dateType: DateType &#x3D; DateType.NOW): promise.Promise&lt;UseCaseMetaData&gt; {
  log(
    &#x60;create use case: withElection&#x3D;${election}, withVotation&#x3D;${votation}, type&#x3D;${type}, canton&#x3D;${canton}, groupedVotation&#x3D;${groupedVotation}, dateType&#x3D;${dateType}&#x60;);
  return doRequest(
    &#x60;mock/create-use-case?withElection&#x3D;${election}&amp;withVotation&#x3D;${votation}&amp;type&#x3D;${type}&amp;canton&#x3D;${canton}&amp;groupedVotation&#x3D;${groupedVotation}&amp;dateType&#x3D;${dateType}&#x60;);
}


export function burnVotingCard(protocolInstanceId: string, voterId: string,
                               type: &#x27;AUTHENTICATION&#x27; | &#x27;CONFIRMATION&#x27; | &#x27;NONE&#x27;) {
  return doRequest(&#x60;mock/voting-card/burn?protocolId&#x3D;${protocolInstanceId}&amp;voterIndex&#x3D;${voterId}&amp;burningType&#x3D;${type}&#x60;);
}

export function setUserStatusInVrum(protocolInstanceId: string,
                                    voterId: string,
                                    status: &quot;READY_TO_VOTE&quot; | &quot;ALREADY_VOTED&quot; | &quot;VERIFICATION_CODE_REVEALED&quot;) {
  return doRequest(&#x60;mock/vrum/set-status?protocolInstanceId&#x3D;${protocolInstanceId}&amp;voterId&#x3D;${voterId}&amp;status&#x3D;${status}&#x60;);
}
</code></pre>
    </div>
</div>






                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'interface';
            var COMPODOC_CURRENT_PAGE_URL = 'UseCaseMetaData.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
